"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var TruncateContext_1 = __importDefault(require("./TruncateContext"));
var Provider = TruncateContext_1.default.Provider;
function Truncate(_a) {
    var children = _a.children, _b = _a.isTruncating, isTruncating = _b === void 0 ? true : _b;
    var ref = react_1.useRef();
    var _c = react_1.useState(null), truncateIndex = _c[0], setTruncateIndex = _c[1];
    var _d = react_1.useState(false), done = _d[0], setDone = _d[1];
    var observer = react_1.useMemo(function () {
        return new IntersectionObserver(function (entries) {
            entries.forEach(function (entry) {
                if (!(entry.target instanceof HTMLElement))
                    return;
                var _a = entry.target.dataset.observeIndex, observeIndex = _a === void 0 ? '' : _a;
                if (entry.isIntersecting &&
                    entry.intersectionRatio < 1) {
                    if (observeIndex.includes('ellipsis')) {
                        setTruncateIndex(function (prev) { return prev - 1; });
                    }
                    else {
                        setTruncateIndex(parseInt(observeIndex));
                    }
                }
                if (entry.isIntersecting &&
                    entry.intersectionRatio === 1 &&
                    observeIndex.includes('ellipsis')) {
                    setDone(true);
                }
                // in case no intersection even though elements are overflowing
                if (!entry.isIntersecting) {
                    setTruncateIndex(function (prev) {
                        return prev === null ? parseInt(observeIndex) - 1 : prev;
                    });
                }
            });
        }, {
            root: ref.current,
            rootMargin: '0px',
        });
    }, []);
    react_1.useEffect(function () {
        setTruncateIndex(null);
        setDone(false);
    }, [children]);
    var wrapper = react_1.default.Children.only(children);
    var newWrapper = react_1.default.cloneElement(wrapper, {
        style: __assign(__assign({}, wrapper.props.style), (isTruncating ? { overflow: 'hidden', flexWrap: 'nowrap' } : {})),
        ref: ref,
    });
    var context = {
        observer: observer,
        truncateIndex: truncateIndex,
        isTruncating: isTruncating,
        done: done
    };
    return react_1.default.createElement(Provider, { value: context }, newWrapper);
}
exports.default = Truncate;
