var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useRef, useMemo, useState } from 'react';
import context from './TruncateContext';
var Provider = context.Provider;
function Truncate(_a) {
    var children = _a.children, _b = _a.isTruncating, isTruncating = _b === void 0 ? true : _b;
    var ref = useRef();
    var _c = useState(null), truncateIndex = _c[0], setTruncateIndex = _c[1];
    var _d = useState(false), done = _d[0], setDone = _d[1];
    var observer = useMemo(function () {
        return new IntersectionObserver(function (entries) {
            entries.forEach(function (entry) {
                if (!(entry.target instanceof HTMLElement))
                    return;
                var _a = entry.target.dataset.observeIndex, observeIndex = _a === void 0 ? '' : _a;
                if (entry.isIntersecting &&
                    entry.intersectionRatio < 1) {
                    if (observeIndex.includes('ellipsis')) {
                        setTruncateIndex(function (prev) { return prev - 1; });
                    }
                    else {
                        setTruncateIndex(parseInt(observeIndex));
                    }
                }
                if (entry.isIntersecting &&
                    entry.intersectionRatio === 1 &&
                    observeIndex.includes('ellipsis')) {
                    setDone(true);
                }
                // in case no intersection even though elements are overflowing
                if (!entry.isIntersecting) {
                    setTruncateIndex(function (prev) {
                        return prev === null ? parseInt(observeIndex) - 1 : prev;
                    });
                }
            });
        }, {
            root: ref.current,
            rootMargin: '0px',
        });
    }, []);
    useEffect(function () {
        setTruncateIndex(null);
        setDone(false);
    }, [children]);
    var wrapper = React.Children.only(children);
    var newWrapper = React.cloneElement(wrapper, {
        style: __assign(__assign({}, wrapper.props.style), (isTruncating ? { overflow: 'hidden', flexWrap: 'nowrap' } : {})),
        ref: ref,
    });
    var context = {
        observer: observer,
        truncateIndex: truncateIndex,
        isTruncating: isTruncating,
        done: done
    };
    return React.createElement(Provider, { value: context }, newWrapper);
}
export default Truncate;
