import React, { useRef, useEffect } from 'react';
function TruncateItem(_a) {
    var children = _a.children, id = _a.id, observer = _a.observer;
    var ref = useRef();
    useEffect(function () {
        var node = ref.current;
        if (node && observer) {
            observer.observe(node);
        }
        return function () {
            if (node && observer) {
                observer.unobserve(node);
            }
        };
    }, [id, observer]);
    var child = React.Children.only(children);
    return React.cloneElement(child, { ref: ref, 'data-observe-index': id });
}
export default TruncateItem;
