var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { forwardRef } from 'react';
import context from './TruncateContext';
import TruncateItem from './TruncateItem';
function TruncateList(_a) {
    var children = _a.children, _b = _a.ellipsis, Ellipsis = _b === void 0 ? forwardRef(function (props, ref) { return React.createElement("div", __assign({ ref: ref }, props), "..."); }) : _b;
    var _c = React.useContext(context), truncateIndex = _c.truncateIndex, observer = _c.observer, isTruncating = _c.isTruncating, done = _c.done;
    if (!isTruncating)
        return React.createElement(React.Fragment, null, children);
    return (React.createElement(React.Fragment, null,
        React.Children.map(children, function (child, index) {
            return truncateIndex !== null ? (index < truncateIndex && child) : (React.createElement(TruncateItem, { id: index, observer: observer }, child));
        }),
        truncateIndex && Ellipsis && (React.createElement(React.Fragment, null, done ? (React.createElement(Ellipsis, { moreCount: React.Children.count(children) - truncateIndex, moreChildren: React.Children.toArray(children).slice(truncateIndex) })) : (React.createElement(TruncateItem, { id: "ellipsis-" + truncateIndex, observer: observer },
            React.createElement(Ellipsis, { moreCount: React.Children.count(children) - truncateIndex, moreChildren: React.Children.toArray(children).slice(truncateIndex) })))))));
}
export default TruncateList;
